/*----------------------------------------------------------------------------
 *
 *  maptest.c - program to test getch() and addch() mapping
 *
 *  Location: /usr/local/src/ecurses/maptest.c
 *
 *  Author: Frank Meyer
 *----------------------------------------------------------------------------
 */

#include <ecurses.h>

#define c8_isprint(ch)   ((ch) >= 32)
#define c8_isiso8(ch)    ((ch) >= 0 && (ch) < 256) 

extern char * keyname ();

main ()
{
  int ch;                                   /* key to be read */
  unsigned char buf[128];                   /* sprintf buffer */
  unsigned char * p;                        /* pointer        */

  initscr ();                               /* intialize tty  */

  while ((ch = getch ()) != 'q')            /* read until     */
  {                                         /* user types 'q' */
    if (ch < 0)                             /* illegal key ?  */
    {                                       /* yes ...        */
      strcpy (buf, "Unknown key!\n");
    }
    else                                    /* key is ok ...  */
    {                                       /* fill buffer    */
      sprintf (buf,
               "Scan Code: %04x  Name: %-20s  Character: %c\n",
               ch, keyname (ch),
               c8_isiso8(ch) && c8_isprint(ch) ? ch : ' ');
    }

    for (p = buf; *p; p++)                  /* output buffer  */
    {                                       /* with addch()   */
      addch (*p);
    }
  }

  endwin ();                                /* restore tty    */

  return (OK);
} /* main () */
